'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _textareaCaret = require('textarea-caret');

var _textareaCaret2 = _interopRequireDefault(_textareaCaret);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lodash = require('lodash.throttle');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MAX_PARTICLES = 500;
var PARTICLE_NUM_RANGE = function PARTICLE_NUM_RANGE() {
  return 5 + Math.round(Math.random() * 5);
};
var PARTICLE_GRAVITY = 0.075;
var PARTICLE_ALPHA_FADEOUT = 0.96;
var PARTICLE_VELOCITY_RANGE = {
  x: [-1, 1],
  y: [-3.5, -1.5]
};
var COLORS = ['#1f77b4', '#ff7f0e', '#2ca02c', '#d62728', '#9467bd', '#8c564b', '#e377c2', '#bcbd22', '#17becf'];

var RagePower = function (_React$Component) {
  _inherits(RagePower, _React$Component);

  function RagePower(props, context) {
    _classCallCheck(this, RagePower);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(RagePower).call(this, props, context));

    _this._drawFrame = _this._drawFrame.bind(_this);
    _this._onInput = _this._onInput.bind(_this);
    _this._shake = (0, _lodash2.default)(_this._shake.bind(_this), 100, { trailing: false });
    _this._spawnParticles = (0, _lodash2.default)(_this._spawnParticles.bind(_this), 25, { trailing: false });
    _this._particles = [];
    return _this;
  }

  _createClass(RagePower, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.canvas = document.createElement('canvas');
      this.canvas.width = window.innerWidth;
      this.canvas.height = window.innerHeight;
      this.canvas.style.position = 'absolute';
      this.canvas.style.top = '0';
      this.canvas.style.pointerEvents = 'none';
      this.canvasContext = this.canvas.getContext('2d');
      document.body.appendChild(this.canvas);
      window.requestAnimationFrame(this._drawFrame);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.body.removeChild(this.canvas);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var _ = _props.colors;

      var others = _objectWithoutProperties(_props, ['children', 'style', 'colors']);

      var newChildren = _react2.default.cloneElement(children, {
        onInput: this._onInput
      });

      return _react2.default.createElement(
        'div',
        _extends({}, others, {
          style: _extends({ position: 'relative' }, style),
          ref: function ref(_ref) {
            return _this2.node = _ref;
          }
        }),
        newChildren
      );
    }

    /**
     * Following code is ported from: https://atom.io/packages/power-mode
     */

  }, {
    key: '_drawFrame',
    value: function _drawFrame() {
      var _this3 = this;

      this.canvasContext.clearRect(0, 0, this.canvas.width, this.canvas.height);
      this._particles.forEach(function (particle) {
        particle.velocity.y += PARTICLE_GRAVITY;
        particle.x += particle.velocity.x;
        particle.y += particle.velocity.y;
        particle.alpha *= PARTICLE_ALPHA_FADEOUT;

        _this3.canvasContext.fillStyle = 'rgba(' + particle.color.join(',') + ', ' + particle.alpha + ')';
        _this3.canvasContext.fillRect(Math.round(particle.x - 1), Math.round(particle.y - 1), 3, 3);
      });
      this._particles = this._particles.slice(Math.max(this._particles.length - MAX_PARTICLES, 0)).filter(function (particle) {
        return particle.alpha > 0.1;
      });
      window.requestAnimationFrame(this._drawFrame);
    }
  }, {
    key: '_shake',
    value: function _shake() {
      var _this4 = this;

      var intensity = 1 + 2 * Math.random();
      var x = intensity * (Math.random() > 0.5 ? -1 : 1);
      var y = intensity * (Math.random() > 0.5 ? -1 : 1);

      this.node.style.transform = 'translate3d(' + x + 'px, ' + y + 'px, 0)';

      setTimeout(function () {
        return _this4.node.style.transform = '';
      }, 75);
    }
  }, {
    key: '_spawnParticles',
    value: function _spawnParticles(x, y) {
      var colors = this.props.colors;

      var numParticles = PARTICLE_NUM_RANGE();
      for (var i = 0; i < numParticles; i++) {
        var colorCode = colors[i % colors.length];
        var r = parseInt(colorCode.slice(1, 3), 16);
        var g = parseInt(colorCode.slice(3, 5), 16);
        var b = parseInt(colorCode.slice(5, 7), 16);
        var color = [r, g, b];
        this._particles.push(this._createParticle(x, y, color));
      }
    }
  }, {
    key: '_createParticle',
    value: function _createParticle(x, y, color) {
      return {
        x: x,
        y: y,
        alpha: 1,
        color: color,
        velocity: {
          x: PARTICLE_VELOCITY_RANGE.x[0] + Math.random() * (PARTICLE_VELOCITY_RANGE.x[1] - PARTICLE_VELOCITY_RANGE.x[0]),
          y: PARTICLE_VELOCITY_RANGE.y[0] + Math.random() * (PARTICLE_VELOCITY_RANGE.y[1] - PARTICLE_VELOCITY_RANGE.y[0])
        }
      };
    }
  }, {
    key: '_onInput',
    value: function _onInput() {
      var _this5 = this;

      var onInput = this.props.onInput;

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      onInput && onInput.apply(undefined, args);
      this._shake();
      var target = args[0].target;
      var origin = target.getBoundingClientRect();

      var _getCaretCoordinates = (0, _textareaCaret2.default)(target, target.selectionEnd);

      var top = _getCaretCoordinates.top;
      var left = _getCaretCoordinates.left;

      var charHeight = parseInt(getComputedStyle(target)['font-size']);
      setTimeout(function () {
        return _this5._spawnParticles(left + origin.left, top + origin.top + charHeight);
      }, 0);
    }
  }]);

  return RagePower;
}(_react2.default.Component);

RagePower.propTypes = {
  children: _react.PropTypes.node,
  onInput: _react.PropTypes.func,
  colors: _react.PropTypes.array
};
RagePower.defaultProps = {
  colors: COLORS
};
exports.default = RagePower;
